// ConsoleApplication1.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include <tchar.h>
#include <iostream>
#include <fstream>
#include <time.h>
#include <cmath>
#include <string>
#include "SharedFileOut.h"
#include "Serial.h"

#define PI 3.14159265358979323846
#define BUF_SIZE 100


using namespace std;


template <typename T, unsigned S>
inline unsigned arraysize(const T(&v)[S])
{
	return S;
}


struct SMElement
{
	HANDLE hMapFile;
	unsigned char* mapFileBuffer;
};

SMElement m_graphics;
SMElement m_physics;
SMElement m_static;

void initPhysics()
{
	TCHAR szName[] = TEXT("Local\\acpmf_physics");
	m_physics.hMapFile = CreateFileMapping(INVALID_HANDLE_VALUE, NULL, PAGE_READWRITE, 0, sizeof(SPageFilePhysics), szName);
	if (!m_physics.hMapFile)
	{
		MessageBoxA(GetActiveWindow(), "CreateFileMapping failed", "ACS", MB_OK);
	}
	m_physics.mapFileBuffer = (unsigned char*)MapViewOfFile(m_physics.hMapFile, FILE_MAP_READ, 0, 0, sizeof(SPageFilePhysics));
	if (!m_physics.mapFileBuffer)
	{
		MessageBoxA(GetActiveWindow(), "MapViewOfFile failed", "ACS", MB_OK);
	}
}

void initGraphics()
{
	TCHAR szName[] = TEXT("Local\\acpmf_graphics");
	m_graphics.hMapFile = CreateFileMapping(INVALID_HANDLE_VALUE, NULL, PAGE_READWRITE, 0, sizeof(SPageFileGraphic), szName);
	if (!m_graphics.hMapFile)
	{
		MessageBoxA(GetActiveWindow(), "CreateFileMapping failed", "ACS", MB_OK);
	}
	m_graphics.mapFileBuffer = (unsigned char*)MapViewOfFile(m_graphics.hMapFile, FILE_MAP_READ, 0, 0, sizeof(SPageFileGraphic));
	if (!m_graphics.mapFileBuffer)
	{
		MessageBoxA(GetActiveWindow(), "MapViewOfFile failed", "ACS", MB_OK);
	}
}

void initStatic()
{
	TCHAR szName[] = TEXT("Local\\acpmf_static");
	m_static.hMapFile = CreateFileMapping(INVALID_HANDLE_VALUE, NULL, PAGE_READWRITE, 0, sizeof(SPageFileStatic), szName);
	if (!m_static.hMapFile)
	{
		MessageBoxA(GetActiveWindow(), "CreateFileMapping failed", "ACS", MB_OK);
	}
	m_static.mapFileBuffer = (unsigned char*)MapViewOfFile(m_static.hMapFile, FILE_MAP_READ, 0, 0, sizeof(SPageFileStatic));
	if (!m_static.mapFileBuffer)
	{
		MessageBoxA(GetActiveWindow(), "MapViewOfFile failed", "ACS", MB_OK);
	}
}

void dismiss(SMElement element)
{
	UnmapViewOfFile(element.mapFileBuffer);
	CloseHandle(element.hMapFile);
}

void printData(string name, float value)
{
	wcout << name.c_str() << " : " << value << endl;
}

template <typename T, unsigned S>
inline void printData(const string name, const T(&v)[S])
{
	wcout << name.c_str() << " : ";
	for (int i = 0; i < S; i++)
	{
		wcout << v[i];
		if (i < S - 1)
		{
			wcout << " , ";
		}
	}
	wcout << endl;
}

const string currentDateTime() {
    time_t now = time(0); // ð time_t Ÿ 
    struct tm tstruct;
    char buf[80];
    localtime_s(&tstruct,&now);
    strftime(buf, sizeof(buf), "%Y%m%d_%H%M%S", &tstruct); // YYYYmmdd_HHMMSS  Ʈ

    return buf;
}





int _tmain(int argc, _TCHAR* argv[])
{
	//   
	string path1 = "D:/FileIO/DB/AC_Telemetry_";
	string path2 = ".txt";
	string rtPath = "D:/FileIO/DB/AC_TELE_REALTIME.csv";
	
	ifstream fIn;
	ofstream fLog;
	ofstream fOut;

	float accGain = 10;
	float yL=0,yR=0,L,degL=0,degR=0,degPreL=0,degPreR=0,filter,maxDeg;
	
	char buffer[100];
	memset(buffer, 0, sizeof(buffer));
	int i,j,k;
	float acc[3], accBuf[3][100];
	bool isAccSame=false;

	// ø Ʈ 
	Serial* SP = new Serial("COM4");    // ڽ Ʈȣ Էսô!
 
	if (SP->IsConnected())
		printf("Connected\n");
	else
	{
		printf("NOT connected\n");
		return 0;
	}


	cout << "please press password" << endl;
	// 0714  Ʒ while  Ѿ
	while (GetAsyncKeyState(0x30) == 0){} //  0  
	while (GetAsyncKeyState(0x37) == 0){} //  7  
	while (GetAsyncKeyState(0x31) == 0){} //  1  
	while (GetAsyncKeyState(0x34) == 0){} //  4  
	cout << "password correct!" << endl;

	/*
	fLog.open(path1 + currentDateTime() + path2);
	fLog << "AccX\tAccY\tAccZ\tVelX\tVelY\tVelZ\tHeading\tRoll\tPitch\tSpeed" << endl;
	*/

	initPhysics();
	//initGraphics();
	//initStatic();


	//  ʱȭ
	filter = 1;
	L=67;
	maxDeg = 30;
	
	for(i=0;i<3;i++){
		acc[i] = 0.0;
		for(j=0;j<100;j++){
			accBuf[i][j] = 0.0;
		}
	}

	while (true)
	{
		SPageFilePhysics* pf = (SPageFilePhysics*)m_physics.mapFileBuffer;


		for(i=0;i<3;i++){
			acc[i] = pf->accG[i]; // ӵ  
			for(j=0;j<99;j++){
				accBuf[i][j+1] = accBuf[i][j]; // ӵ queue   .
			}
			accBuf[i][0] = acc[i];
		}

		// queue  ӵ   ˻
		isAccSame = true;
		for(i=0;i<3;i++)
			for(j=0;j<98;j++)
				isAccSame *= accBuf[i][j]==accBuf[i][j+1];


		// ӵ   , Է  Ŷ  acc 0 
		if(isAccSame)
			for(i=0;i<3;i++)
				acc[i]=0.0;
		

		/*
		// ǿ  Ϸ 
		if(acc[0]+acc[1]+acc[2] != 0){ //  ÿ
			fLog << pf->accG[0];
			fLog << '\t';
			fLog << pf->accG[1];
			fLog << '\t';
			fLog << pf->accG[2];
			fLog << '\t';
			fLog << pf->velocity[0];
			fLog << '\t';
			fLog << pf->velocity[1];
			fLog << '\t';
			fLog << pf->velocity[2];
			fLog << '\t';
			fLog << pf->heading;
			fLog << '\t';
			fLog << pf->roll;
			fLog << '\t';
			fLog << pf->pitch;
			fLog << '\t';
			fLog << pf->speedKmh;
			fLog << endl;
		}
		*/


		//////////////////////////////////////////
		// ǥ ȯ κ

		// acc deg ȯ
		acc[0] = acc[0]*accGain*PI/180;
		acc[2] = acc[2]*accGain*PI/180;
    
		yL = L/2*(cos(acc[2])*sin(acc[0])-cos(acc[0])*sin(acc[2]));
		yR = -L/2*(cos(acc[2])*sin(acc[0])+cos(acc[0])*sin(acc[2]));
		
		//  ùķʹ  κ ٲ 
		degL = filter*(2*yL)+(1-filter)*degPreL;
		degR = filter*(2*yR)+(1-filter)*degPreR;

		
        // deg /ó
		if(degL>maxDeg) degL = maxDeg;
		else if(degL<-maxDeg) degL = -maxDeg;
    
		if (degR > maxDeg) degR = maxDeg;
		else if(degR < -maxDeg) degR = -maxDeg;

		// ǥ ȯ κ
		//////////////////////////////////////////



		// ڸ ڿ ȯ
		char degLch[30],degRch[30];

		sprintf_s(degLch, sizeof(degLch),"%.9f", degL);
		sprintf_s(degRch, sizeof(degRch),"%.9f", degR);


		// ڿ ʱȭ (NULL)
		for(i=0;i<BUF_SIZE;i++){
			buffer[i] = 0;
		}

		//   ڿ Ŀ ߾ 
		k=0;
		j=0;
		while(degLch[j] != 0){
			buffer[k] = degLch[j];
			k++;
			j++;
		}
		buffer[k]=',';
		k++;
		j=0;
		while(degRch[j]!=0){
			buffer[k] = degRch[j];
			k++;
			j++;
		}
		buffer[k]=',';
		

		// Ƶ̳ ۽
		SP->WriteData(buffer, sizeof(buffer));


		// ͸  簪  
		degPreL = degL;
		degPreR = degR;

		/*
		if (GetAsyncKeyState(0x43) & 0x8000){ // c 
			cout << " Log ended & New file created" << endl;

			fOut.open(rtPath);
			fOut << '0,0' << endl;
			fOut.close();

			fLog.close(); //  α ϰ
			fLog.open(path1 + currentDateTime() + path2); //  α 
			fLog << "AccX\tAccY\tAccZ\tVelX\tVelY\tVelZ\tHeading\tPitch\tRoll\tSpeed" << endl;
			Sleep(500);
		}

		if(GetAsyncKeyState(0x51) & 0x8000){ // q 
			cout << "Program Finished" << endl;

			fOut.open(rtPath);
			fOut << '0,0' << endl;
			fOut.close();
			
			fLog.close();
			break; // α׷ 
		}
		*/

		Sleep(50);
	}

	dismiss(m_physics);
	//dismiss(m_graphics);
	//dismiss(m_static);
	
	return 0;
}


